Loading...
Searching...
No Matches
juce::HighResolutionTimer Class Referenceabstract

## Detailed Description

A high-resolution periodic timer.

This provides accurately-timed regular callbacks. Unlike the normal Timer class, this one uses a dedicated thread, not the message thread, so is far more stable and precise.

You should only use this class in situations where you really need accuracy, because unlike the normal Timer class, which is very lightweight and cheap the HighResolutionTimer will use far more resources and require thread safety considerations.

See also
  Timer

The documentation for this class was generated from the following file:

- juce_core/threads/juce_HighResolutionTimer.h

## Public Member Functions

virtual | ~HighResolutionTimer ()
| Destructor.
virtual void | hiResTimerCallback ()=0
| The user-defined callback routine that actually gets called periodically.
void | startTimer (int intervalInMilliseconds)
| Starts the timer and sets the length of interval required.
void | stopTimer ()
| Stops the timer.
bool | isTimerRunning () const noexcept
| Checks if the timer has been started.
int | getTimerInterval () const noexcept
| Returns the timer's interval.

## Protected Member Functions

| HighResolutionTimer ()
| Creates a HighResolutionTimer.

## Constructors and Destructors

## HighResolutionTimer()

juce::HighResolutionTimer::HighResolutionTimer | ( |  | ) |

protected

Creates a HighResolutionTimer.

When created, the timer is stopped, so use startTimer() to get it going.

Referenced by getTimerInterval().

## ~HighResolutionTimer()

virtual juce::HighResolutionTimer::~HighResolutionTimer | ( |  | ) |

virtual

Destructor.

## Member Functions

## hiResTimerCallback()

virtual void juce::HighResolutionTimer::hiResTimerCallback | ( |  | ) |

pure virtual

The user-defined callback routine that actually gets called periodically.

This will be called on a dedicated timer thread, so make sure your implementation is thread-safe!

On some platforms the dedicated timer thread may be shared with other HighResolutionTimer's so aim to complete any work in this callback as fast as possible.

It's perfectly ok to call startTimer() or stopTimer() from within this callback to change the subsequent intervals. However, if you call stopTimer() in the callback it's still best practice to call stopTimer() from the destructor in order to avoid data races.

## startTimer()

void juce::HighResolutionTimer::startTimer | ( | int | intervalInMilliseconds | ) |

Starts the timer and sets the length of interval required.

If the timer has already started, this will reset the timer, so the time between calling this method and the next timer callback will not be less than the interval length passed in.

In exceptional circumstances the dedicated timer thread may not start, if this is a potential concern for your use case, you can call isTimerRunning() to confirm if the timer actually started.

On Windows the underlying API only allows 16 high-resolution timers to run simultaneously in the same process. A fallback timer will be used when this limit is exceeded but the precision may be significantly compromised. This is a particular concern for plugins, because other plugins in the same host process may already have timers running. To avoid issues, try to use the minimum number of HighResolutionTimers possible. For example, consider using a SharedResourcePointer so that all instances of the same plugin running in the same same process can share a single HighResolutionTimer instance.

Parameters

  intervalInMilliseconds | the interval to use (a value of zero or less will stop the timer)

## stopTimer()

void juce::HighResolutionTimer::stopTimer | ( |  | ) |

Stops the timer.

This method may block while it waits for pending callbacks to complete. Once it returns, no more callbacks will be made. If it is called from the timer's own thread, it will cancel the timer after the current callback returns.

To prevent data races it's normally best practice to call this in the derived classes destructor, even if stopTimer() was called in the hiResTimerCallback().

## isTimerRunning()

bool juce::HighResolutionTimer::isTimerRunning | ( |  | ) | const

noexcept

Checks if the timer has been started.

Returns
  true if the timer is running.

## getTimerInterval()

int juce::HighResolutionTimer::getTimerInterval | ( |  | ) | const

noexcept

Returns the timer's interval.

Returns
  the timer's interval in milliseconds if it's running, or 0 if it's not.

References getTimerInterval(), HighResolutionTimer(), and JUCE_DECLARE_NON_COPYABLE_WITH_LEAK_DETECTOR.

Referenced by getTimerInterval().

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited